<script lang="ts">
    import Button from '../../components/Button/Button.svelte'
    import { createEventDispatcher } from 'svelte';

    const dispatch = createEventDispatcher();

    interface IUserData {
        name: {
            name: string,
            first: string,
            last: string,
        },
        picture: {
            large: string
        }
    }
    
    // user data from https://randomuser.me/
    export let userDataPromise: Promise<IUserData> | undefined

    let disabled = true
    $: {
        disabled = true
        userDataPromise
            ?.catch(()=>{})
            .then((x => disabled = false))
    }

    function getRandomUser() {
        // fired on click to render another radom user
        dispatch('getRandomUser')
    }

    function getUserFullName(userData) {
        const userName = userData?.name
        return userName ? `${userName.title} ${userName.first} ${userName.last}` : null
    }
</script>

{#await userDataPromise}
    <p>Carregando ...</p>
{:then userData} 
    <img src={ userData?.picture?.large } alt="">
    <p>{ getUserFullName(userData) }</p>
{:catch error} 
    <p>{ error }</p>
{/await}

<div class:disabled>
    <Button on:click={ () => !disabled && getRandomUser() } primary={ true }>
        Render radom user
    </Button>
</div>


<style lang="scss">
    .disabled {
        opacity: .2;
        cursor: unset;
    }
</style>